//----------------------------------------------------------------------------
// Dialogs.hpp - bcbdcc32 generated hdr (DO NOT EDIT) rev: 0
// From: Dialogs.pas
//----------------------------------------------------------------------------
#ifndef DialogsHPP
#define DialogsHPP
//----------------------------------------------------------------------------
#include <Forms.hpp>
#include <Controls.hpp>
#include <Graphics.hpp>
#include <Classes.hpp>
#include <CommDlg.hpp>
#include <SysUtils.hpp>
#include <Messages.hpp>
#include <Windows.hpp>
#include <System.hpp>
#pragma warn -par
#pragma warn -hid 
#pragma warn -inl

namespace Dialogs
{
//-- type declarations -------------------------------------------------------
class __declspec(delphiclass) TCommonDialog;
class __declspec(pascalimplementation) TCommonDialog : public Classes::TComponent
{
	typedef Classes::TComponent inherited;
	
private:
	bool FCtl3D;
	Classes::THelpContext FHelpContext;
	
protected:
	virtual bool __fastcall Message(Messages::TMessage &Msg);
	virtual DWord __fastcall TaskModalDialog(void * DialogFunc, void *DialogData);
	
public:
	__fastcall virtual TCommonDialog(Classes::TComponent* AOwner);
	
__published:
	__property bool Ctl3D = {read=FCtl3D, write=FCtl3D, default=1};
	__property Classes::THelpContext HelpContext = {read=FHelpContext, write=FHelpContext, default=0};
public:
		
	/* TComponent.Destroy */ __fastcall virtual ~TCommonDialog(void) { }
	
};

enum TOpenOption { ofReadOnly, ofOverwritePrompt, ofHideReadOnly, ofNoChangeDir, ofShowHelp, ofNoValidate, 
	ofAllowMultiSelect, ofExtensionDifferent, ofPathMustExist, ofFileMustExist, ofCreatePrompt, ofShareAware, 
	ofNoReadOnlyReturn, ofNoTestFileCreate, ofNoNetworkButton, ofNoLongNames, ofOldStyleDialog, ofNoDereferenceLinks 
	};

typedef Set<TOpenOption, ofReadOnly, ofNoDereferenceLinks>  TOpenOptions;

enum TFileEditStyle { fsEdit, fsComboBox };

class __declspec(delphiclass) TOpenDialog;
class __declspec(pascalimplementation) TOpenDialog : public TCommonDialog
{
	typedef TCommonDialog inherited;
	
private:
	Classes::TStrings* FHistoryList;
	TOpenOptions FOptions;
	System::AnsiString FFilter;
	int FFilterIndex;
	System::AnsiString FInitialDir;
	System::AnsiString FTitle;
	System::AnsiString FDefaultExt;
	System::AnsiString FFileName;
	Classes::TStrings* FFiles;
	TFileEditStyle FFileEditStyle;
	void __fastcall SetHistoryList(Classes::TStrings* Value);
	void __fastcall SetInitialDir(const System::AnsiString Value);
	DWord __fastcall DoExecute(void * Func);
	
public:
	__fastcall virtual TOpenDialog(Classes::TComponent* AOwner);
	__fastcall virtual ~TOpenDialog(void);
	virtual bool __fastcall Execute(void);
	__property Classes::TStrings* Files = {read=FFiles, nodefault};
	
__published:
	__property System::AnsiString DefaultExt = {read=FDefaultExt, write=FDefaultExt, nodefault};
	__property TFileEditStyle FileEditStyle = {read=FFileEditStyle, write=FFileEditStyle, nodefault};
	__property System::AnsiString FileName = {read=FFileName, write=FFileName, nodefault};
	__property System::AnsiString Filter = {read=FFilter, write=FFilter, nodefault};
	__property int FilterIndex = {read=FFilterIndex, write=FFilterIndex, default=1};
	__property Classes::TStrings* HistoryList = {read=FHistoryList, write=SetHistoryList, nodefault};
	__property System::AnsiString InitialDir = {read=FInitialDir, write=SetInitialDir, nodefault};
	__property TOpenOptions Options = {read=FOptions, write=FOptions, default=0};
	__property System::AnsiString Title = {read=FTitle, write=FTitle, nodefault};
};

class __declspec(delphiclass) TSaveDialog;
class __declspec(pascalimplementation) TSaveDialog : public TOpenDialog
{
	typedef TOpenDialog inherited;
	
__published:
	virtual bool __fastcall Execute(void);
public:
	/* TOpenDialog.Create */ __fastcall virtual TSaveDialog(Classes::TComponent* AOwner) : Dialogs::TOpenDialog(
		AOwner) { }
	/* TOpenDialog.Destroy */ __fastcall virtual ~TSaveDialog(void) { }
	
};

enum TColorDialogOption { cdFullOpen, cdPreventFullOpen, cdShowHelp, cdSolidColor, cdAnyColor };

typedef Set<TColorDialogOption, cdFullOpen, cdAnyColor>  TColorDialogOptions;

typedef long TCustomColors[16];

class __declspec(delphiclass) TColorDialog;
class __declspec(pascalimplementation) TColorDialog : public TCommonDialog
{
	typedef TCommonDialog inherited;
	
private:
	Graphics::TColor FColor;
	TColorDialogOptions FOptions;
	Classes::TStrings* FCustomColors;
	void __fastcall SetCustomColors(Classes::TStrings* Value);
	
public:
	__fastcall virtual TColorDialog(Classes::TComponent* AOwner);
	__fastcall virtual ~TColorDialog(void);
	bool __fastcall Execute(void);
	
__published:
	__property Graphics::TColor Color = {read=FColor, write=FColor, default=0};
	__property Ctl3D ;
	__property Classes::TStrings* CustomColors = {read=FCustomColors, write=SetCustomColors, nodefault}
		;
	__property TColorDialogOptions Options = {read=FOptions, write=FOptions, default=0};
};

enum TFontDialogOption { fdAnsiOnly, fdTrueTypeOnly, fdEffects, fdFixedPitchOnly, fdForceFontExist, 
	fdNoFaceSel, fdNoOEMFonts, fdNoSimulations, fdNoSizeSel, fdNoStyleSel, fdNoVectorFonts, fdShowHelp, 
	fdWysiwyg, fdLimitSize, fdScalableOnly, fdApplyButton };

typedef Set<TFontDialogOption, fdAnsiOnly, fdApplyButton>  TFontDialogOptions;

enum TFontDialogDevice { fdScreen, fdPrinter, fdBoth };

typedef void __fastcall (__closure *TFDApplyEvent)(System::TObject* Sender, HWND Wnd);

class __declspec(delphiclass) TFontDialog;
class __declspec(pascalimplementation) TFontDialog : public TCommonDialog
{
	typedef TCommonDialog inherited;
	
private:
	Graphics::TFont* FFont;
	TFontDialogDevice FDevice;
	TFontDialogOptions FOptions;
	TFDApplyEvent FOnApply;
	int FMinFontSize;
	int FMaxFontSize;
	void __fastcall DoApply(HWND Wnd);
	void __fastcall SetFont(Graphics::TFont* Value);
	void __fastcall UpdateFromLogFont(const LOGFONTA &LogFont);
	
protected:
	virtual void __fastcall Apply(HWND Wnd);
	
public:
	__fastcall virtual TFontDialog(Classes::TComponent* AOwner);
	__fastcall virtual ~TFontDialog(void);
	bool __fastcall Execute(void);
	
__published:
	__property Graphics::TFont* Font = {read=FFont, write=SetFont, nodefault};
	__property TFontDialogDevice Device = {read=FDevice, write=FDevice, default=0};
	__property int MinFontSize = {read=FMinFontSize, write=FMinFontSize, nodefault};
	__property int MaxFontSize = {read=FMaxFontSize, write=FMaxFontSize, nodefault};
	__property TFontDialogOptions Options = {read=FOptions, write=FOptions, default=4};
	__property TFDApplyEvent OnApply = {read=FOnApply, write=FOnApply};
};

class __declspec(delphiclass) TPrinterSetupDialog;
class __declspec(pascalimplementation) TPrinterSetupDialog : public TCommonDialog
{
	typedef TCommonDialog inherited;
	
public:
	void __fastcall Execute(void);
public:
	/* TCommonDialog.Create */ __fastcall virtual TPrinterSetupDialog(Classes::TComponent* AOwner) : Dialogs::
		TCommonDialog(AOwner) { }
	
public:
	/* TComponent.Destroy */ __fastcall virtual ~TPrinterSetupDialog(void) { }
	
};

enum TPrintRange { prAllPages, prSelection, prPageNums };

enum TPrintDialogOption { poPrintToFile, poPageNums, poSelection, poWarning, poHelp, poDisablePrintToFile 
	};

typedef Set<TPrintDialogOption, poPrintToFile, poDisablePrintToFile>  TPrintDialogOptions;

class __declspec(delphiclass) TPrintDialog;
class __declspec(pascalimplementation) TPrintDialog : public TCommonDialog
{
	typedef TCommonDialog inherited;
	
private:
	int FFromPage;
	int FToPage;
	bool FCollate;
	TPrintDialogOptions FOptions;
	bool FPrintToFile;
	TPrintRange FPrintRange;
	int FMinPage;
	int FMaxPage;
	int FCopies;
	void __fastcall SetNumCopies(int Value);
	
public:
	bool __fastcall Execute(void);
	
__published:
	__property bool Collate = {read=FCollate, write=FCollate, default=0};
	__property int Copies = {read=FCopies, write=SetNumCopies, default=0};
	__property int FromPage = {read=FFromPage, write=FFromPage, default=0};
	__property int MinPage = {read=FMinPage, write=FMinPage, default=0};
	__property int MaxPage = {read=FMaxPage, write=FMaxPage, default=0};
	__property TPrintDialogOptions Options = {read=FOptions, write=FOptions, default=0};
	__property bool PrintToFile = {read=FPrintToFile, write=FPrintToFile, default=0};
	__property TPrintRange PrintRange = {read=FPrintRange, write=FPrintRange, default=0};
	__property int ToPage = {read=FToPage, write=FToPage, default=0};
public:
	/* TCommonDialog.Create */ __fastcall virtual TPrintDialog(Classes::TComponent* AOwner) : Dialogs::
		TCommonDialog(AOwner) { }
	
public:
	/* TComponent.Destroy */ __fastcall virtual ~TPrintDialog(void) { }
	
};

enum TFindOption { frDown, frFindNext, frHideMatchCase, frHideWholeWord, frHideUpDown, frMatchCase, 
	frDisableMatchCase, frDisableUpDown, frDisableWholeWord, frReplace, frReplaceAll, frWholeWord, frShowHelp 
	};

typedef Set<TFindOption, frDown, frShowHelp>  TFindOptions;

typedef HWND __stdcall (*TFindReplaceFunc)(tagFINDREPLACEA &FindReplace);

class __declspec(delphiclass) TFindDialog;
class __declspec(pascalimplementation) TFindDialog : public TCommonDialog
{
	typedef TCommonDialog inherited;
	
private:
	TFindOptions FOptions;
	POINT FPosition;
	HWND FHandle;
	TFindReplaceFunc FFindReplaceFunc;
	Controls::TWinControl* FRedirector;
	Classes::TNotifyEvent FOnFind;
	Classes::TNotifyEvent FOnReplace;
	FINDREPLACEA FFindReplace;
	char FFindText[256];
	char FReplaceText[256];
	System::AnsiString __fastcall GetFindText(void);
	int __fastcall GetLeft(void);
	POINT __fastcall GetPosition(void);
	System::AnsiString __fastcall GetReplaceText(void);
	int __fastcall GetTop(void);
	void __fastcall SetFindText(const System::AnsiString Value);
	void __fastcall SetLeft(int Value);
	void __fastcall SetPosition(const POINT &Value);
	void __fastcall SetReplaceText(const System::AnsiString Value);
	void __fastcall SetTop(int Value);
	__property System::AnsiString ReplaceText = {read=GetReplaceText, write=SetReplaceText, nodefault};
		
	__property Classes::TNotifyEvent OnReplace = {read=FOnReplace, write=FOnReplace};
	
protected:
	virtual bool __fastcall Message(Messages::TMessage &Msg);
	virtual void __fastcall Find(void);
	virtual void __fastcall Replace(void);
	
public:
	__fastcall virtual TFindDialog(Classes::TComponent* AOwner);
	__fastcall virtual ~TFindDialog(void);
	void __fastcall CloseDialog(void);
	bool __fastcall Execute(void);
	__property HWND Handle = {read=FHandle, nodefault};
	__property int Left = {read=GetLeft, write=SetLeft, nodefault};
	__property POINT Position = {read=GetPosition, write=SetPosition};
	__property int Top = {read=GetTop, write=SetTop, nodefault};
	
__published:
	__property System::AnsiString FindText = {read=GetFindText, write=SetFindText, nodefault};
	__property TFindOptions Options = {read=FOptions, write=FOptions, default=1};
	__property Classes::TNotifyEvent OnFind = {read=FOnFind, write=FOnFind};
};

class __declspec(delphiclass) TReplaceDialog;
class __declspec(pascalimplementation) TReplaceDialog : public TFindDialog
{
	typedef TFindDialog inherited;
	
public:
	__fastcall virtual TReplaceDialog(Classes::TComponent* AOwner);
	
__published:
	__property ReplaceText ;
	__property OnReplace ;
public:
	/* TFindDialog.Destroy */ __fastcall virtual ~TReplaceDialog(void) { }
	
};

enum TMsgDlgType { mtWarning, mtError, mtInformation, mtConfirmation, mtCustom };

enum TMsgDlgBtn { mbYes, mbNo, mbOK, mbCancel, mbAbort, mbRetry, mbIgnore, mbAll, mbHelp };

typedef Set<TMsgDlgBtn, mbYes, mbHelp>  TMsgDlgButtons;

//-- var, const, procedure ---------------------------------------------------
#define MaxCustomColors (Byte)(16)
#define mbYesNoCancel 0xB
#define mbOKCancel 0xC
#define mbAbortRetryIgnore 0x70
extern Forms::TForm* __fastcall CreateMessageDialog(const System::AnsiString Msg, TMsgDlgType DlgType
	, TMsgDlgButtons Buttons);
extern int __fastcall MessageDlg(const System::AnsiString Msg, TMsgDlgType DlgType, TMsgDlgButtons Buttons
	, long HelpCtx);
extern int __fastcall MessageDlgPos(const System::AnsiString Msg, TMsgDlgType DlgType, TMsgDlgButtons 
	Buttons, long HelpCtx, int X, int Y);
extern void __fastcall ShowMessage(const System::AnsiString Msg);
extern void __fastcall ShowMessagePos(const System::AnsiString Msg, int X, int Y);
extern bool __fastcall InputQuery(const System::AnsiString ACaption, const System::AnsiString APrompt
	,  System::AnsiString &Value);
extern System::AnsiString __fastcall InputBox(const System::AnsiString ACaption, const System::AnsiString 
	APrompt, const System::AnsiString ADefault);
extern void __fastcall finalization(void);
//-- template instantiations -------------------------------------------------
template class TMsgDlgButtons ;
template class TFindOptions ;
template class TPrintDialogOptions ;
template class TFontDialogOptions ;
template class TColorDialogOptions ;
template class TOpenOptions ;

}	/* namespace Dialogs */

#pragma warn .par
#pragma warn .hid 
#pragma warn .inl

#if !defined(NO_IMPLICIT_NAMESPACE_USE)
using namespace Dialogs;
#endif
//-- end unit ----------------------------------------------------------------
#endif	// Dialogs
